#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include "pc6001v.h"

#define	FSIZE		(6)	// ptHg̕

// F`
#define	FC_BLACK	(0)
#define	FC_DBLUE	(1)
#define	FC_DGREEN	(2)
#define	FC_DCYAN	(3)
#define	FC_DRED		(4)
#define	FC_DMAGENTA	(5)
#define	FC_DYELLOW	(6)
#define	FC_GRAY		(7)
#define	FC_BLUE		(9)
#define	FC_GREEN	(10)
#define	FC_CYAN		(11)
#define	FC_RED		(12)
#define	FC_MAGENTA	(13)
#define	FC_YELLOW	(14)
#define	FC_WHITE	(15)



////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class JFont {
protected:
	static SDL_Surface *ZFont;	// SptHgf[^T[tFXւ̃|C^
	static SDL_Surface *HFont;	// ptHgf[^T[tFXւ̃|C^
	
	static int zWidth,zHeight;	// Sp̕,
	static int hWidth,hHeight;	// p̕,
	
public:
	JFont();									// RXgN^
	~JFont();									// fXgN^
	
	static BOOL OpenFont( char *, char * );		// t@Ct@CJ
	static void CloseFont();					// tHgj
	
	static int FontWidth(){ return hWidth; }	// tHg̕擾(p)
	static int FontHeight(){ return hHeight; }	// tHg̍擾
	
	void PutCharh( SDL_Surface*, int, int, Uint8,  Uint8, Uint8 );	// p`
	void PutCharz( SDL_Surface*, int, int, Uint16, Uint8, Uint8 );	// Sp`

};


class ZCons : public JFont {
protected:
	SDL_Surface *Surf;			// R\[T[tFXւ̃|C^
	SDL_Rect con;				// `͈
	int Xmax,Ymax;				// cő啶(p)
	int x,y;					// J[\ʒu
	Uint8 fgc,bgc;				// `FƔwiF
	char Caption[129];			// LvV
	
	SDL_Rect pos;				// \ʒuƃTCY
	
	void DrawFrame();			// g`
	void ScrollUp();			// XN[Abv
	
public:
	ZCons();									// RXgN^
	virtual ~ZCons();							// fXgN^
	
	SDL_Surface *CreateRes( int, int, const char *, int = FC_WHITE, int = FC_BLACK );	// R\[쐬(𑜓xŃTCYw)
	SDL_Surface *Create( int, int, const char *, int = FC_WHITE, int = FC_BLACK );		// R\[쐬(ŃTCYw)
	void Locate( int, int );					// J[\ʒuݒ
	void LocateR( int, int );					// J[\ʒuݒ(΍W)
	void SetColor( Uint8, Uint8 );				// `Fݒ
	void SetColor( Uint8 );
	void Cls();									// ʏ
	
	void PutCharH( Uint8 );						// p1`
	void PutCharZ( Uint16 );					// Sp1`
	
	void Print( const char *, ... );			// t`(䕶Ή)
	void Printf( const char *, ... );			// t`(䕶Ή)
	void Printfr( const char *, ... );			// t`(El)
	
	int Width() { return Surf ? Surf->w : 0; }	// R\[̕擾
	int Height(){ return Surf ? Surf->h : 0; }	// R\[̍擾
	
	int GetXline(){ return Xmax; }				// ő啶擾
	int GetYline(){ return Ymax; }				// cő啶擾
	
	
	void SetPos( int x, int y ){ pos.x = x; pos.y = y; }	// \ʒuݒ
	SDL_Rect *GetPos(){ return &pos; }			// \ʒu擾
	void Show( SDL_Rect * = NULL );				// XN[ɕ\
};


#endif	// CONSOLE_H_INCLUDED
