#ifndef PC6001V_H_INCLUDED
#define PC6001V_H_INCLUDED

#include <memory.h>

#include <SDL.h>


/////////////////////////////////////////////////////////////////////////////
// rhIvV (svȍڂ̓RgAEg)
/////////////////////////////////////////////////////////////////////////////
// j^[h̎gp
#define	USEMONITOR


/////////////////////////////////////////////////////////////////////////////
// o[W,@햼Ȃ
/////////////////////////////////////////////////////////////////////////////
#define	VERSION		"1.11"
#define	APPNAME		"PC6001V"
#define	P60NAME		"PC-6001"
#define	P62NAME		"PC-6001mk2"
#define	P66NAME		"PC-6601"
#define	P64NAME		"PC-6001mk2SR"
#define	P68NAME		"PC-6601SR"


/////////////////////////////////////////////////////////////////////////////
// IvV l
/////////////////////////////////////////////////////////////////////////////
#define	DEFAULT_MODEL			(60)				/* @ 60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR */
#define	DEFAULT_EXTRAM			(1)					/* gRAM 0:Ȃ 1: */
#define	DEFAULT_REPEAT			(70)				/* L[s[g̊Ԋu(P:ms 0Ŗ) */
#define	DEFAULT_SAMPLE_RATE		(44100)				/* TvO[g */
#define	SOUND_BUFFER_SIZE		(1)					/* TEhobt@{({VSYNC) */
#define	DEFAULT_MASTERVOL		(70)				/* }X^[ */
#define	DEFAULT_PSGVOL			(40)				/* PSG */
#define	DEFAULT_PSGLPF			(0)					/* PSG LPFJbgItg(0Ŗ) */
#define	DEFAULT_VOICEVOL		(100)				/*  */
#define	DEFAULT_TAPEVOL			(20)				/* TAPEj^ */
#define	DEFAULT_TAPELPF			(1540)				/* TAPE LPFJbgItg(0Ŗ) */
#define	DEFAULT_TURBO			(TRUE)				/* Turbo TAPE Yes:L No: */
#define	DEFAULT_BOOST			(TRUE)				/* BoostUp Yes:L No: */
#define DEFAULT_MAXBOOST60		(9)					/* BoostUpő{(N60[h) */
#define DEFAULT_MAXBOOST62		(5)					/* BoostUpő{(N60m/N66[h) */
#define	DEFAULT_FDD				(0)					/* FDDڑ䐔 */
#define	DEFAULT_COLOR_MODE		(16)				/* J[[h 8:8bit 16:bit 24:24bit */
#define	DEFAULT_MODE4_COLOR		(1)					/* [hSJ[[h 0:m 1:/ 2:/ 3:sN/ 4:/sN */
#define	DEFAULT_SCANLINE		(FALSE) 			/* XLC TRUE: FALSE:Ȃ */
#define	DEFAULT_SCANLINEBR		(50)				/* XLCPx (0-100)% */
#define	DEFAULT_DISPNTSC		(TRUE) 				/* 4:3\ TRUE:L FALSE: */
#define	DEFAULT_FRAMESKIP		(0)					/* t[XLbv */
#define	DEFAULT_OVERCLOCK		(100)				/* I[o[NbN */
#define	DEFAULT_CHECKCRC		(TRUE) 				/* CRC`FbN */
#define	DEFAULT_ROMPATCH		(TRUE) 				/* ROMpb` */
#define	DEFAULT_FULLSCREEN		(FALSE) 			/* tXN[ */
#define	DEFAULT_DISPSTATUS		(TRUE) 				/* Xe[^Xo[\ */
#define	DEFAULT_AVIRLE			(TRUE) 				/* RLEtO */
#define	DEFAULT_CKQUIT			(FALSE) 			/* ImF */
#define	DEFAULT_SAVEQUIT		(TRUE) 				/* IINIۑ */
#define	DEFAULT_SOLDIER			(FALSE) 			/* m̃J[gbWgtO */


#define	CPU_CLOCK				(3993600)			/* CPUNbN(Hz) */
#define	VSYNC_HZ				(60)				/* VSYNCg */
#define	DEFAULT_TIMER_HZ		(487.5)				/* ^C}ݎg l */
#define	UTIMER_HZ				(DEFAULT_TIMER_HZ*4)
#define	DEFAULT_BAUD			(1200)				/* CMT{[[g l */
#define	DEFAULT_CMT_HZ			(DEFAULT_BAUD/12)	/* CMTݎg l (1byte -> StartBit:1 + DataBit:8 + StopBit:3 = 12bits Ƃ) */
#define	PSG_CLOCK				(CPU_CLOCK/2)		/* PSGNbN(Hz) */

//#define	DEFAULT_FPS_CNT			(TRUE)			/* FPSJE^ TRUE:\ FALSE:\ */

// SDLT[tFXpIvV
#define SDLOP_SCREEN			(SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWACCEL)
#define SDLOP_SURFACE			(SDL_SWSURFACE | SDL_HWACCEL)

/////////////////////////////////////////////////////////////////////////////
// efBNg l
/////////////////////////////////////////////////////////////////////////////
#define	ROM_DIR			"rom"			/* ROMC[W */
#define	TAPE_DIR		"tape"			/* TAPEC[W */
#define	DISK_DIR		"disk"			/* DISKC[W */
#define	EXTROM_DIR		"extrom"		/* gROMC[W */
#define	IMAGE_DIR		"img"			/* XibvVbg */
#define	FONT_DIR		"font"			/* tHg */
#define	WAVE_DIR		"wave"			/* WAVEt@C */


/////////////////////////////////////////////////////////////////////////////
// et@C l
/////////////////////////////////////////////////////////////////////////////
#define	CONF_FILE		"pc6001v.ini"	/* ݒt@C */
#define	PRINTER_FILE	"printer.txt"	/* v^o̓t@C */
#define	DOKODEMO_FILE	"dokodemo.dds"	/* ǂłSAVEt@C */
#define	SERIAL_FILE		"serial.txt"	/* VAo̓t@C */
#define	SAVE_FILE		"_csave.p6t"	/* TAPE(CSAVE)t@C */
#define	FONTZ_FILE		"fontz12.png"	/* ptHgt@C */
#define	FONTH_FILE		"fonth12.png"	/* SptHgt@C */
#define	FONTV_FILE		"cgrom60s.60"	/* VDGtHgt@C */

#define	SUBCPU60		"subcpu.60"		/* TuCPU ROM(PC-6001) */
#define	SUBCPU62		"subcpu.62"		/* TuCPU ROM(PC-6001mk2) */
#define	SUBCPU66		"subcpu.66"		/* TuCPU ROM(PC-6601) */
/////////////////////////////////////////////////////////////////////////////
// ^,萔`
/////////////////////////////////////////////////////////////////////////////
#ifdef WIN32
#include <windows.h>
#else
typedef int BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef MAX_PATH
#define	MAX_PATH	(260)
#endif


/////////////////////////////////////////////////////////////////////////////
// ėp}N
/////////////////////////////////////////////////////////////////////////////
#define STATIC_CAST(t, o)	static_cast<t> (o)

#define FGETBYTE(fp)		((BYTE)fgetc(fp))
#define FGETWORD(fp)		((WORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)))
#define FGETDWORD(fp)		((DWORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)|((BYTE)fgetc(fp)<<16)|((BYTE)fgetc(fp)<<24)))
#define FPUTBYTE(data,fp)	fputc(data&0xff,fp)
#define FPUTWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); }
#define FPUTDWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); fputc((data>>16)&0xff,fp); fputc((data>>24)&0xff,fp); }

#define CTODW(a,b,c,d)		((DWORD)(((BYTE)(a))|(((DWORD)((BYTE)(b)))<<8)|(((DWORD)((BYTE)(c)))<<16)|(((DWORD)((BYTE)(d)))<<24)))

#if SDL_BYTEORDER == SDL_LIL_ENDIAN

#define GET3BYTE(a,b,c,p)	{ a = *((BYTE *)p++); b = *((BYTE *)p++); c = *((BYTE *)p++); }
#define PUT3BYTE(a,b,c,p)	{ *((BYTE *)p++) = a; *((BYTE *)p++) = b; *((BYTE *)p++) = c; }
#define BTODW(a,b,c,d)		((DWORD)(((BYTE)(a))|(((DWORD)((BYTE)(b)))<<8)|(((DWORD)((BYTE)(c)))<<16)|(((DWORD)((BYTE)(d)))<<24)))
#define DWTOB(s,a,b,c,d)	{ a = (BYTE)((s>>24)&0x000000ff); b = (BYTE)((s>>16)&0x000000ff); c = (BYTE)((s>>8)&0x000000ff); d = (BYTE)(s&0x000000ff); }

#else

#define GET3BYTE(a,b,c,p)	{ c = *((BYTE *)p++); b = *((BYTE *)p++); a = *((BYTE *)p++); }
#define PUT3BYTE(a,b,c,p)	{ *((BYTE *)p++) = c; *((BYTE *)p++) = b; *((BYTE *)p++) = a; }
#define BTODW(a,b,c,d)		((DWORD)(((BYTE)(d))|(((DWORD)((BYTE)(c)))<<8)|(((DWORD)((BYTE)(b)))<<16)|(((DWORD)((BYTE)(a)))<<24)))
#define DWTOB(s,a,b,c,d)	{ d = (BYTE)((s>>24)&0x000000ff); c = (BYTE)((s>>16)&0x000000ff); b = (BYTE)((s>>8)&0x000000ff); a = (BYTE)(s&0x000000ff); }

#endif

#define	COUNTOF(arr)		(int)(sizeof(arr)/sizeof((arr)[0]))

#ifndef ZeroMemory
#define ZeroMemory(d,l)	memset((d), 0, (l))
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

// MacpR[hϊ ShiftJIS -> UTF-8
#ifdef __APPLE__
#define FOPENEN(a,b)	fopen(Sjis2UTF8(a),b)
#else
#define FOPENEN(a,b)	fopen(a,b)
#endif

/////////////////////////////////////////////////////////////////////////////
// SDL [U[`Cxg
/////////////////////////////////////////////////////////////////////////////
#define SENDEVENT(etype)		{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			SDL_PushEvent( &ev ); }

#define SENDEVENT1(etype,data)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.code = data;	\
			SDL_PushEvent( &ev ); }

#define SENDEVENT2(etype,d1,d2)	{						\
			SDL_Event ev;								\
			ev.type = etype;							\
			ev.user.code = ((d1)<<16)|((d2)&0xffff);	\
			SDL_PushEvent( &ev ); }

#define SENDEVENTP(etype,pnt)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.data1 = pnt;	\
			SDL_PushEvent( &ev ); }


#define SDL_DRAWSCREEN	(SDL_USEREVENT)
#define SDL_FPSUPDATE	(SDL_USEREVENT+1)
#define SDL_RESTART		(SDL_USEREVENT+2)

#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define SDL_DEBUGMODEBP	(SDL_USEREVENT+10)
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


/////////////////////////////////////////////////////////////////////////////
// fobO֌W
/////////////////////////////////////////////////////////////////////////////
// Oꍇ1ɂ
#define KEY_LOG		0	/* L[͊֌W */
#define MEM_LOG		0	/* ֌W */
#define TAPE_LOG	0	/* TAPE֌W */
#define P6T2_LOG	0	/* P6T2֌W */
#define DISK_LOG	0	/* DISK֌W */
#define FDC_LOG		0	/* FDC֌W */
#define D88_LOG		0	/* D88֌W */
#define PSG_LOG		0	/* PSG֌W */
#define INTR_LOG	0	/* ݊֌W */
#define CPU_LOG		0	/* CPU֌W */
#define SUB_LOG		0	/* TuCPU֌W */
#define PPI_LOG		0	/* 8255֌W */
#define SND_LOG		0	/* Sound֌W */
#define GRP_LOG		0	/* `֌W */
#define OSD_LOG		0	/* OSˑ֌W */
#define TIC_LOG		0	/* XPW[֌W */
#define INI_LOG		0	/* INI֌W */
#define CON_LOG		0	/* RXgN^֌W */
#define IO_LOG		0	/* I/O֌W */
#define WIN_LOG		0	/* EBhE֌W */
#define CONST_LOG	0	/* RXgN^EfXgN^֌W */
#define VOI_LOG		0	/* ֌W */

#if KEY_LOG || MEM_LOG || TAPE_LOG || P6T2_LOG || DISK_LOG || D88_LOG || FDC_LOG || PSG_LOG || INTR_LOG || CPU_LOG || SUB_LOG || PPI_LOG || SND_LOG || GRP_LOG || OSD_LOG || TIC_LOG || INI_LOG || CON_LOG || IO_LOG || WIN_LOG || CONST_LOG || VOI_LOG
 #define LOG_ON
#endif

#if defined(LOG_ON)
 #include <stdio.h>
 #define PRINTD(m,s)			{ if( m ){ fprintf( stdout, (s) );							fflush( stdout); } }
 #define PRINTD1(m,s,a)			{ if( m ){ fprintf( stdout, (s), (a) );						fflush( stdout); } }
 #define PRINTD2(m,s,a,b)		{ if( m ){ fprintf( stdout, (s), (a), (b) );				fflush( stdout); } }
 #define PRINTD3(m,s,a,b,c)		{ if( m ){ fprintf( stdout, (s), (a), (b), (c) );			fflush( stdout); } }
 #define PRINTD4(m,s,a,b,c,d)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d) );		fflush( stdout); } }
 #define PRINTD5(m,s,a,b,c,d,e)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d), (e) );	fflush( stdout); } }
#else
 #define PRINTD(m,s)
 #define PRINTD1(m,s,a)
 #define PRINTD2(m,s,a,b)
 #define PRINTD3(m,s,a,b,c)
 #define PRINTD4(m,s,a,b,c,d)
 #define PRINTD5(m,s,a,b,c,d,e)
#endif


#endif	// PC6001V_H_INCLUDED
